#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2000eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 2000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight20004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight20004xi = {
                1:'-1006x-1129y-1307z',
                2:'-1029x-267y-1693z',
                3:'-102x-359y-1964z',
                4:'-1036x-1708y-79z',
                5:'-1038x-1312y-1095z',
                6:'-1073x-1084y-1292z',
                7:'-109x-659y-1884z',
                8:'-1112x-1264y-1079z',
                9:'-1125x-1652y-59z',
                10:'-1138x-1035y-1277z',
                11:'-1184x-1211y-1062z',
                12:'-1200x-982y-1261z',
                13:'-1210x-1591y-39z',
                14:'-1254x-1155y-1045z',
                15:'-1260x-926y-1246z',
                16:'-127x-372y-1960z',
                17:'-1292x-1526y-19z',
                18:'-1317x-865y-1230z',
                19:'-1320x-1094y-1028z',
                20:'-133x-1338y-1479z',
                21:'-1370x-1456y0z',
                22:'-1371x-801y-1214z',
                23:'-1384x-1030y-1010z',
                24:'-1422x-734y-1198z',
                25:'-143x-1535y-1272z',
                26:'-1444x-961y-993z',
                27:'-1469x-663y-1182z',
                28:'-147x-1977y-258z',
                29:'-147x-671y-1878z',
                30:'-1501x-889y-976z',
                31:'-1513x-590y-1166z',
                32:'-153x-383y-1956z',
                33:'-1553x-513y-1150z',
                34:'-1554x-814y-958z',
                35:'-1589x-434y-1133z',
                36:'-1603x-736y-940z',
                37:'-1620x-353y-1117z',
                38:'-1647x-269y-1100z',
                39:'-1648x-654y-923z',
                40:'-1670x-184y-1083z',
                41:'-1689x-570y-905z',
                42:'-1725x-483y-887z',
                43:'-1757x-394y-869z',
                44:'-181x-392y-1952z',
                45:'-187x-680y-1871z',
                46:'-19x-294y-1978z',
                47:'-205x-1344y-1466z',
                48:'-211x-399y-1948z',
                49:'-225x-1538y-1257z',
                50:'-229x-687y-1863z',
                51:'-241x-404y-1943z',
                52:'-250x-1969y-239z',
                53:'-271x-692y-1856z',
                54:'-273x-407y-1938z',
                55:'-278x-1346y-1452z',
                56:'-306x-408y-1933z',
                57:'-308x-1537y-1241z',
                58:'-315x-693y-1849z',
                59:'-339x-406y-1928z',
                60:'-352x-1343y-1438z',
                61:'-353x-1956y-219z',
                62:'-359x-692y-1841z',
                63:'-373x-402y-1923z',
                64:'-37x-312y-1975z',
                65:'-391x-1530y-1226z',
                66:'-404x-688y-1833z',
                67:'-407x-395y-1917z',
                68:'-426x-1337y-1424z',
                69:'-43x-1979y-278z',
                70:'-442x-386y-1911z',
                71:'-450x-682y-1825z',
                72:'-456x-1937y-199z',
                73:'-474x-1519y-1210z',
                74:'-476x-374y-1905z',
                75:'-496x-672y-1817z',
                76:'-4x-275y-1980z',
                77:'-501x-1326y-1410z',
                78:'-511x-359y-1899z',
                79:'-542x-659y-1808z',
                80:'-545x-342y-1893z',
                81:'-557x-1504y-1194z',
                82:'-557x-1912y-179z',
                83:'-575x-1311y-1396z',
                84:'-579x-322y-1886z',
                85:'-57x-329y-1971z',
                86:'-588x-643y-1800z',
                87:'-612x-300y-1880z',
                88:'-62x-1329y-1493z',
                89:'-62x-1528y-1288z',
                90:'-633x-624y-1791z',
                91:'-640x-1483y-1178z',
                92:'-644x-275y-1873z',
                93:'-649x-1291y-1381z',
                94:'-657x-1882y-159z',
                95:'-675x-247y-1866z',
                96:'-678x-602y-1782z',
                97:'-705x-217y-1858z',
                98:'-722x-1458y-1161z',
                99:'-723x-1267y-1367z',
                100:'-723x-576y-1773z',
                101:'-733x-184y-1851z',
                102:'-755x-1846y-139z',
                103:'-760x-149y-1843z',
                104:'-766x-548y-1763z',
                105:'-76x-678y-1986z',
                106:'-785x-112y-1835z',
                107:'-78x-345y-1968z',
                108:'-795x-1239y-1352z',
                109:'-803x-1429y-1145z',
                110:'-808x-72y-1827z',
                111:'-809x-517y-1754z',
                112:'-850x-482y-1744z',
                113:'-851x-1805y-119z',
                114:'-867x-1207y-1337z',
                115:'-883x-1394y-1129z',
                116:'-890x-445y-1734z',
                117:'-928x-405y-1724z',
                118:'-937x-1170y-1322z',
                119:'-945x-1759y-99z',
                120:'-961x-1355y-1112z',
                121:'-964x-361y-1714z',
                122:'-998x-316y-1704z '}         

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2000eight4xi" usage = "target function for charge2000eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2000eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2000EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2000EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2000EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2000EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2000EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight20004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2000EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2000EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2000EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight20004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight20004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2000EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2000EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2000EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2000eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  